/*
  Copyright (C) 2002 INRIA, Ecole des Mines de Nantes, Univerity of Copenhagen
  Automatically generated from Bossa specification by the cb compiler
  --- Do not edit this file ---
  To compile for use as a module, compile with options "gcc -O -DMODULE"*/

/* checksum = 21541 */
#ifndef EXPORTS
#define EXPORTS linux_sched_ops
#endif
#ifndef NAME
#define NAME "linux"
#endif
#define PROCESS_SCHEDULER
struct Linux_bossa_struct;
#define PROTOCOL_PROCESS_STRUCT   struct Linux_bossa_struct
#define PROTOCOL_SCHEDULER_STRUCT struct scheduler_struct
#define PROTOCOL_BOSSA_STRUCT     struct Linux_bossa_struct
/* Compile with options "gcc -O -D__KERNEL__ " */
#ifdef __KERNEL__
   #include <linux/sched.h>
   #include <linux/string.h>
   #include <linux/slab.h>
   #include <asm/mmu_context.h>
   #include <linux/interrupt.h>
   #include <linux/smp_lock.h>
   #include <linux/errno.h>
   #include <linux/list.h>
   #include <linux/prefetch.h>
#else
   struct timer_list { int x; };
   #include "bossa.h"
   struct task_struct { int pid; void *mm; char *comm; };
   #define kmalloc(x,y) malloc(x)
   #define kfree(x) free(x)
   #define GFP_ATOMIC 0
   #define panic printf
#endif
#define array_ref(x,y,z) x[y].z
#define field_array_ref(x,y,z) x->y[z]
#define sizeof_struct(x) sizeof(struct x)
#define UNBLOCK_INFO_OFFSET 0
#define drop_unblock_res(x) (x&~(1<<UNBLOCK_INFO_OFFSET))
#define get_unblock_res(x) (x&(1<<UNBLOCK_INFO_OFFSET))
#define set_current_need_resched(n) current->need_resched = n
#define SUCCESS 0
#define FAILURE -1
#define time_to_ticks(x) x
#define ticks_to_time(x) x

/* includes for interface functions */
#include <linux/types.h>
//#include <linux/errno.h>
//#include <linux/sched.h>
#include <linux/fs.h>
#include <linux/unistd.h>
//#include <linux/slab.h>
#include <linux/devfs_fs_kernel.h>
#include <asm/uaccess.h>
#include <linux/ioctl.h>


#define bossa_assert(x) do{if(!(x)) panic("Error in " #x "\n");} while(0)
#define state_of(e) ((e)->state)
#define update_state(e,s,c) ((e)->state=(s))
#define event_mask0(e) ((e) & 0xff000000)
#define event_mask1(e) ((e) & 0xffff0000)
#define event_mask2(e) ((e) & 0xffffff00)
#define event_mask3(e) ((e) & 0xffffffff)
#define true 1
#define false 0
#define null NULL
typedef int bool;
typedef void * port;
static char *error_string;

#define  NOWHERE_15_STATE  0
#define  RUNNING_0_STATE  1 << 0
#define  READY_STATE  1 << 1
#define  EXPIRED_STATE  1 << 2
#define  YIELD_STATE  1 << 3
#define  BLOCKED_STATE  1 << 4
#define  TERMINATED_STATE  1 << 5

extern spinlock_t bossa_scheduler_lock;
extern struct bossa_struct *rts_idle_process;
enum policy_t
{
  BOSSA_SCHED_FIFO = 0, BOSSA_SCHED_RR = 1, BOSSA_SCHED_OTHER = 2
};

struct Linux_bossa_struct {
  /* default attributes for Bossa */
  /* next and previous processes in the current bossa queue */
  struct list_head list_info;
  /* list of virtual schedulers on the way to this process */
  struct next_list_struct *next_list;
  int state;
  /* Additional process attributes
   *  specified by the scheduling policy
   *  in the process = {...} declaration
  */
  enum policy_t policy;
  int rt_priority;
  int priority;
  int ticks;
  unsigned long block_time;
  int block_event;
  //system struct mm_struct * active_mm;
};

extern enum SchedState root_s_state;

static struct mm_struct * running_active_mm = NULL;

#ifdef MODULE
/************ Routines related to modules *************/
static int __init Linux_init_module(void);
static void __exit Linux_cleanup_module(void);
/******************************************************/
#endif
/******** to know if the module is being used ********/
static inline void increment_ref_count(void);
static inline void decrement_ref_count(void);
/******************************************************/

static void Linux_scheduler_init (void);
static int Linux_ioctl_init (void);
static int Linux_scheduler(struct event_struct *e,
                           struct next_list_struct *src_next_list,
                           struct next_list_struct *tgt_next_list);
static int Linux_compute_state(struct next_list_struct *next_list);
static int Linux_ps_attach(struct next_list_struct *next_list);
static int Linux_ps_detach(struct next_list_struct *next_list,
                           struct bossa_struct *_p);
static void Linux_attach_self(void);
static PROTOCOL_SCHEDULER_STRUCT *Linux_detach_self(bool is_root);
static uint Linux_check_process_state(struct Linux_bossa_struct *tgt,
                                      struct next_list_struct *next,
                                      uint classes);
static void Linux_preempt(void);
static char *
queueToString(struct list_head *start, char *buffer, bool long_format);
static int Linux_do_taskprocinfo(struct next_list_struct *, struct bossa_struct *, char *, bool, bool, bool);
static int Linux_do_schedprocinfo(char *, bool);
static int Linux_list_sched_info(char * page,char ** start,off_t off,
				 int count,int * eof,void * data);
static int Linux_count_processes(void);
static void Linux_print_processes(void);
static void Linux_set_priority(struct Linux_bossa_struct *, struct next_list_struct *, int);
inline static int Linux_block(
int,
struct Linux_bossa_struct *,
struct next_list_struct *);
inline static int Linux_block_bossa_schedule(void);
static int Linux_block_entry(int,
                             struct Linux_bossa_struct *);
inline static int Linux_yield_system_immediate(int,
                                               struct Linux_bossa_struct *,
                                               struct next_list_struct *);
inline static int Linux_yield_system_immediate_bossa_schedule(void);
static int Linux_yield_system_immediate_entry(int,
                                              struct Linux_bossa_struct *);
inline static int Linux_yield_system_pause(int,
                                           struct Linux_bossa_struct *,
                                           struct next_list_struct *);
inline static int Linux_yield_system_pause_bossa_schedule(void);
static int Linux_yield_system_pause_entry(int,
                                          struct Linux_bossa_struct *);
inline static int Linux_unblock_preemptive(int,
                                           struct Linux_bossa_struct *,
                                           struct next_list_struct *);
static int Linux_unblock_preemptive_entry(int,
                                          struct Linux_bossa_struct *);
inline static int Linux_bossa_schedule(void);
static int Linux_bossa_schedule_entry(void);
inline static int Linux_unblock_timer_target(int,
                                             struct Linux_bossa_struct *,
                                             struct next_list_struct *);
static int Linux_unblock_timer_target_entry(int,
                                            struct Linux_bossa_struct *,
                                            struct next_list_struct *);
inline static int Linux_unblock_timer_notarget(int,
                                               struct Linux_bossa_struct *,
                                               struct next_list_struct *);
static int Linux_unblock_timer_notarget_entry(int,
                                              struct Linux_bossa_struct *,
                                              struct next_list_struct *);
inline static int Linux_unblock_timer_persistent(int,
                                                 struct timer_list *,
                                                 void *,
                                                 int,
                                                 struct Linux_bossa_struct *,
                                                 struct next_list_struct *);
static int Linux_unblock_timer_persistent_entry(int,
                                                struct timer_list *,
                                                void *,
                                                int,
                                                struct Linux_bossa_struct *,
                                                struct next_list_struct *);

static char *sched_type[4] = {"Virtual Scheduler","Process Scheduler","VS","PS"};

struct scheduler_operations EXPORTS = {
  Linux_scheduler,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Linux_block,
  Linux_block_bossa_schedule,
  (int (*)(int,struct bossa_struct *))Linux_block_entry,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Linux_yield_system_immediate,
  Linux_yield_system_immediate_bossa_schedule,
  (int (*)(int,struct bossa_struct *))Linux_yield_system_immediate_entry,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Linux_yield_system_pause,
  Linux_yield_system_pause_bossa_schedule,
  (int (*)(int,struct bossa_struct *))Linux_yield_system_pause_entry,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Linux_unblock_preemptive,
  (int (*)(int,struct bossa_struct *))Linux_unblock_preemptive_entry,
  Linux_bossa_schedule,
  Linux_bossa_schedule_entry,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Linux_unblock_timer_target,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Linux_unblock_timer_target_entry,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Linux_unblock_timer_notarget,
  (int (*)(int,struct bossa_struct *,struct next_list_struct *))Linux_unblock_timer_notarget_entry,
  (int (*)(int,struct timer_list *,void *,int,struct bossa_struct *,struct next_list_struct *))Linux_unblock_timer_persistent,
  (int (*)(int,struct timer_list *,void *,int,struct bossa_struct *,struct next_list_struct *))Linux_unblock_timer_persistent_entry,
  "Linux",
  PS,
  true,
  Linux_scheduler_init,
  Linux_ioctl_init,
  NULL,
  Linux_check_process_state,
  Linux_preempt,
  Linux_do_taskprocinfo,
  Linux_do_schedprocinfo,
  Linux_list_sched_info,
  Linux_count_processes,
  Linux_print_processes,
  Linux_set_priority,
  Linux_compute_state,
  Linux_ps_attach,
  Linux_ps_detach,
  NULL,
  NULL,
  NULL,
  Linux_attach_self,
  Linux_detach_self,
  increment_ref_count,
  decrement_ref_count,
  { NULL, NULL }, // filled in at installation with the path to the scheduler
};

/* definition of protocol states */
#ifndef __KERNEL__
struct bossa_struct *running;
#endif
struct state_info {
  struct Linux_bossa_struct *running_0;
  struct list_head ready;
  struct list_head expired;
  struct Linux_bossa_struct *yield;
  struct list_head blocked;
  struct list_head terminated;
};


static struct state_info state_info __cacheline_aligned;


/*******************************************************
 *
 *	Modification Module
 *
 * *****************************************************/
#ifdef MODULE
   #include <linux/module.h> /* Ncessaire pour tous les modules */
   #include <linux/kernel.h> /* Ncessaire pour le alertes noyau */
   #include <linux/init.h>   /* Ncessaire pour l'utilisation module_init()/_exit()*/
   #include <linux/config.h> /* ?? */
static void unregister(void);
static char scheduler_string[] = "Process Scheduler with Linux";
static char scheduler_version[] = "1.0.1";
static char scheduler_copyright[] = "Copyright (c) 2002 INRIA, Ecole des Mines de Nantes, Univerity of Copenhagen.";

MODULE_AUTHOR("Bossa Compiler");
MODULE_DESCRIPTION("Loading of process scheduler Linux");
MODULE_LICENSE("GPL");

int bossa_add_scheduler(struct scheduler_operations *u_ops, int stat);
void bossa_remove_scheduler(struct scheduler_operations *u_ops);

/******************************************************************************
 * Linux_init_module - Scheduler Registration Routine
 *
 * Linux_init_module is the first routine called when the scheduler is
 * loaded. All it does is add to the list of scheduler and register with the
 * ioctl subsystem.
 * 
 ***************************************************************************/
static int __init Linux_init_module(void) 
{
  printk("<6>%s - version %s\n", scheduler_string, scheduler_version);
  printk(KERN_INFO "%s\n", scheduler_copyright);
  printk(KERN_INFO "Linux_scheduler_init function at %x\n", (unsigned int)Linux_scheduler_init);
  // add to all_schedulers
  if (bossa_add_scheduler(&EXPORTS,0)) return EINVAL;
  // init devfs thingy
  EXPORTS.ioctl_init();
  return 0;
}

module_init(Linux_init_module);
/******************************************************************************
 * Linux_cleanup_module - Scheduler Registration Routine
 *
 * Linux_cleanup_module is the first routine called when the scheduler is
 * unloaded. For instance she does nothing.
 * 
 ***************************************************************************/
static void __exit Linux_cleanup_module(void) 
{
  // unregister ioctl
  unregister();
  // remove the scheduler from the parent, if any
  if (EXPORTS.next_list.prev->prev != &EXPORTS.next_list)
    EXPORTS.next_list.prev->prev->sched->ops->detach(EXPORTS.next_list.prev->sched,true);
  // remove the scheduler from the list of all schedulers
  bossa_remove_scheduler(&EXPORTS);
  
  printk(KERN_INFO "scheduler %s unmounted\n",EXPORTS.name);
}

module_exit(Linux_cleanup_module);
#endif

static inline void increment_ref_count(void) {
#ifdef MODULE
  MOD_INC_USE_COUNT;
#endif
}

static inline void decrement_ref_count(void) {
#ifdef MODULE
  MOD_DEC_USE_COUNT;
#endif
}

/******* Fin de modification pour insertion modulaire *******/

#include "prim1.c"


inline static bool
greater(struct Linux_bossa_struct * p1_22, struct Linux_bossa_struct * p2_23) {
  {
    int pv1_24;
    int pv2_25;
    
    pv1_24 = p1_22->rt_priority;
    pv2_25 = p2_23->rt_priority;
    if (pv1_24 > pv2_25) {
      return true;
    }
    else {
      if (pv1_24 < pv2_25) {
        return false;
      }
    }
  }
  {
    int pv1_24;
    int pv2_25;
    
    if (p1_22->policy == BOSSA_SCHED_OTHER) {
      pv1_24 = p1_22->priority + p1_22->ticks;
    }
    else {
      pv1_24 = 0;
    }
    if (p2_23->policy == BOSSA_SCHED_OTHER) {
      pv2_25 = p2_23->priority + p2_23->ticks;
    }
    else {
      pv2_25 = 0;
    }
    if (pv1_24 > pv2_25) {
      return true;
    }
    else {
      if (pv1_24 < pv2_25) {
        return false;
      }
    }
  }
  {
    int pv1_24;
    int pv2_25;
    
    if ((p1_22->policy == BOSSA_SCHED_OTHER) &&
        (attr(p1_22)->active_mm == running_active_mm)) {
      pv1_24 = 1;
    }
    else {
      pv1_24 = 0;
    }
    if ((p2_23->policy == BOSSA_SCHED_OTHER) &&
        (attr(p2_23)->active_mm == running_active_mm)) {
      pv2_25 = 1;
    }
    else {
      pv2_25 = 0;
    }
    return pv1_24 > pv2_25;
  }
}

inline static bool
greater_lifo_fifo(struct Linux_bossa_struct * p1_26,
                  struct Linux_bossa_struct * p2_27) {
  {
    int pv1_28;
    int pv2_29;
    
    pv1_28 = p1_26->rt_priority;
    pv2_29 = p2_27->rt_priority;
    if (pv1_28 > pv2_29) {
      return true;
    }
    else {
      if (pv1_28 < pv2_29) {
        return false;
      }
    }
  }
  {
    int pv1_28;
    int pv2_29;
    
    if (p1_26->policy == BOSSA_SCHED_OTHER) {
      pv1_28 = p1_26->priority + p1_26->ticks;
    }
    else {
      pv1_28 = 0;
    }
    if (p2_27->policy == BOSSA_SCHED_OTHER) {
      pv2_29 = p2_27->priority + p2_27->ticks;
    }
    else {
      pv2_29 = 0;
    }
    if (pv1_28 > pv2_29) {
      return true;
    }
    else {
      if (pv1_28 < pv2_29) {
        return false;
      }
    }
  }
  {
    int pv1_28;
    int pv2_29;
    
    if ((p1_26->policy == BOSSA_SCHED_OTHER) &&
        (attr(p1_26)->active_mm == running_active_mm)) {
      pv1_28 = 1;
    }
    else {
      pv1_28 = 0;
    }
    if ((p2_27->policy == BOSSA_SCHED_OTHER) &&
        (attr(p2_27)->active_mm == running_active_mm)) {
      pv2_29 = 1;
    }
    else {
      pv2_29 = 0;
    }
    if (pv1_28 > pv2_29) {
      return true;
    }
    else {
      if (pv1_28 < pv2_29) {
        return false;
      }
    }
  }
  if (state_of(p1_26) == READY_STATE) {
    if (state_of(p2_27) == READY_STATE) {
      return first_fifo(&state_info.ready, p1_26, p2_27);
    }
    else {
      return true;
    }
  }
  else {
    return false;
  }
}

inline static int
key_index(struct Linux_bossa_struct * p_54) {
  int acc_56 = 0;
  
  return acc_56;
}

inline static int
static_compare(struct Linux_bossa_struct * p1_50,
               struct Linux_bossa_struct * p2_51) {
  return 0;
}

inline static int
static_select_compare(struct Linux_bossa_struct * p1_46,
                      struct Linux_bossa_struct * p2_47) {
  return static_compare(p1_46, p2_47);
}

inline static bool
dynamic_select_greater(struct Linux_bossa_struct * p1_42,
                       struct Linux_bossa_struct * p2_43) {
  {
    int pv1_44;
    int pv2_45;
    
    pv1_44 = p1_42->rt_priority;
    pv2_45 = p2_43->rt_priority;
    if (pv1_44 > pv2_45) {
      return true;
    }
    else {
      if (pv1_44 < pv2_45) {
        return false;
      }
    }
  }
  {
    int pv1_44;
    int pv2_45;
    
    if (p1_42->policy == BOSSA_SCHED_OTHER) {
      pv1_44 = p1_42->priority + p1_42->ticks;
    }
    else {
      pv1_44 = 0;
    }
    if (p2_43->policy == BOSSA_SCHED_OTHER) {
      pv2_45 = p2_43->priority + p2_43->ticks;
    }
    else {
      pv2_45 = 0;
    }
    if (pv1_44 > pv2_45) {
      return true;
    }
    else {
      if (pv1_44 < pv2_45) {
        return false;
      }
    }
  }
  {
    int pv1_44;
    int pv2_45;
    
    if ((p1_42->policy == BOSSA_SCHED_OTHER) &&
        (attr(p1_42)->active_mm == running_active_mm)) {
      pv1_44 = 1;
    }
    else {
      pv1_44 = 0;
    }
    if ((p2_43->policy == BOSSA_SCHED_OTHER) &&
        (attr(p2_43)->active_mm == running_active_mm)) {
      pv2_45 = 1;
    }
    else {
      pv2_45 = 0;
    }
    return pv1_44 > pv2_45;
  }
}

inline static bool
dynamic_greater(struct Linux_bossa_struct * p1_38,
                struct Linux_bossa_struct * p2_39) {
  return dynamic_select_greater(p1_38, p2_39);
}

inline static bool
static_compare_lifo_fifo(struct Linux_bossa_struct * p1_30,
                         struct Linux_bossa_struct * p2_31) {
  return false;
}

inline static bool
static_select_compare_lifo_fifo(struct Linux_bossa_struct * p1_32,
                                struct Linux_bossa_struct * p2_33) {
  return false;
}

inline static bool
dynamic_select_greater_lifo_fifo(struct Linux_bossa_struct * p1_34,
                                 struct Linux_bossa_struct * p2_35) {
  return false;
}

inline static bool
dynamic_greater_lifo_fifo(struct Linux_bossa_struct * p1_36,
                          struct Linux_bossa_struct * p2_37) {
  return false;
}

static uint Linux_check_process_state(struct Linux_bossa_struct *tgt,
                                      struct next_list_struct *next,
                                      uint classes) {
  switch(tgt->state) {
    case TERMINATED_STATE: return classes & TERMINATED;
    case BLOCKED_STATE: return classes & BLOCKED;
    case YIELD_STATE: return classes & READY;
    case EXPIRED_STATE: return classes & READY;
    case READY_STATE: return classes & READY;
    case RUNNING_0_STATE: return classes & RUNNING;
    default: return 0;
  }
}

#include "prim.c"

static void Linux_scheduler_init(void) {
  /* initialization of states */
  init_var(&state_info.running_0);
  init_queue(&state_info.ready);
  init_queue(&state_info.expired);
  init_var(&state_info.yield);
  init_queue(&state_info.blocked);
  
}

static int Linux_scheduler(struct event_struct *e,
                           struct next_list_struct *src_next_list,
                           struct next_list_struct *tgt_next_list) {
  struct Linux_bossa_struct *tgt = (struct Linux_bossa_struct *)e->target;
  uint _event = (uint)e->type;
  
  prefetch(&state_info);
  switch (event_mask0(_event)) {
    case EVENT_PROCESS:
    {
      uint event_57 = event_mask1(_event);
      if (event_57 == EVENT_PROCESS_END) {
        decrement_ref_count();
        update_state(tgt, TERMINATED_STATE, TERMINATED);
        move_queue_nowhere(tgt /* {blocked} */, &state_info.terminated);
        if (empty_proc(state_info.running_0)) {
          if (empty_queue(&state_info.expired) &&
              empty_queue(&state_info.ready)) {
            running_active_mm = (struct mm_struct *)NULL;
            return BLOCKED;
          }
          else {
            return READY;
          }
        }
        else {
          return RUNNING;
        }
      }
      else if (event_57 == EVENT_PROCESS_NEW) {
        increment_ref_count();
        if (src_next_list != src_next_list->next &&
            src_next_list->sched->ops == &EXPORTS) {
          e->source->ticks = e->source->ticks / 2;
          tgt->priority = e->source->priority;
          tgt->rt_priority = e->source->rt_priority;
          e->source->rt_priority = tgt->rt_priority;
          tgt->policy = e->source->policy;
          tgt->ticks = e->source->ticks;
          if ((e->source->ticks == 0) &&
              (e->source->policy != BOSSA_SCHED_FIFO)) {
            e->source->ticks = (e->source->priority >> 2) + 1;
            tgt->ticks = (tgt->priority >> 2) + 1;
            if (e->source->policy == BOSSA_SCHED_RR) {
              if (state_of(e->source) == RUNNING_0_STATE) {
                struct Linux_bossa_struct * _fresh_17 = e->source;
                
                update_state(_fresh_17, READY_STATE, READY);
                move_proc_fifo(state_info.running_0 /* {running_0} */,
                               &state_info.ready);
                current->need_resched = 1;
              }
              update_state(tgt, READY_STATE, READY);
              move_nowhere_fifo(tgt /* {} */, &state_info.ready);
              return READY;
            }
            else {
              {
                struct Linux_bossa_struct * _fresh_16 = e->source;
                
                if (state_of(_fresh_16) == RUNNING_0_STATE) {
                  move_proc_queue(state_info.running_0 /* {running_0} */,
                                  &state_info.expired);
                  current->need_resched = 1;
                }
                else {
                  move_queue_queue(_fresh_16 /* {ready, expired} */,
                                   &state_info.expired);
                }
                update_state(_fresh_16, EXPIRED_STATE, READY);
              }
              update_state(tgt, EXPIRED_STATE, READY);
              move_nowhere_queue(tgt /* {} */, &state_info.expired);
              return READY;
            }
          }
          else {
            update_state(tgt, READY_STATE, READY);
            move_nowhere_fifo(tgt /* {} */, &state_info.ready);
            if (empty_proc(state_info.running_0)) {
              return READY;
            }
            else {
              return RUNNING;
            }
          }
        }
        else {
          tgt->priority = 20;
          tgt->rt_priority = 0;
          tgt->policy = BOSSA_SCHED_OTHER;
          tgt->ticks = (20 >> 2) + 1;
          update_state(tgt, READY_STATE, READY);
          move_nowhere_fifo(tgt /* {} */, &state_info.ready);
          if (empty_proc(state_info.running_0)) {
            return READY;
          }
          else {
            return RUNNING;
          }
        }
      }
      else panic("Linux: unknown event %x\n",_event);
      return 0;
    }
    case EVENT_SYSTEM:
    {
      if (state_info.running_0->policy != BOSSA_SCHED_FIFO) {
        state_info.running_0->ticks = state_info.running_0->ticks - 1;
        if (state_info.running_0->ticks <= 0) {
          state_info.running_0->ticks =
            (state_info.running_0->priority >> 2) + 1;
          if (state_info.running_0->policy == BOSSA_SCHED_RR) {
            update_state(state_info.running_0, READY_STATE, READY);
            move_proc_fifo(state_info.running_0 /* {running_0} */,
                           &state_info.ready);
            current->need_resched = 1;
            return READY;
          }
          else {
            update_state(state_info.running_0, EXPIRED_STATE, READY);
            move_proc_queue(state_info.running_0 /* {running_0} */,
                            &state_info.expired);
            current->need_resched = 1;
            return READY;
          }
        }
        else {
          return RUNNING;
        }
      }
      else {
        return RUNNING;
      }
    }
    case EVENT_UNBLOCK:
    {
      if (state_of(tgt) == BLOCKED_STATE) {
        update_state(tgt, READY_STATE, READY);
        move_queue_fifo(tgt /* {blocked} */, &state_info.ready);
        if (empty_proc(state_info.running_0)) {
          return READY;
        }
        else {
          return RUNNING;
        }
      }
      else {
        if (empty_proc(state_info.running_0)) {
          return READY;
        }
        else {
          return RUNNING;
        }
      }
    }
    case EVENT_YIELD:
    {
      if (tgt->policy == BOSSA_SCHED_OTHER) {
        if (state_of(tgt) == RUNNING_0_STATE) {
          move_proc_proc(state_info.running_0 /* {running_0} */,
                         state_info.yield);
          current->need_resched = 1;
        }
        else {
          move_queue_proc(tgt /* {ready, expired} */, state_info.yield);
        }
        update_state(tgt, YIELD_STATE, READY);
        return READY;
      }
      else {
        if (state_of(tgt) == RUNNING_0_STATE) {
          update_state(state_info.running_0, READY_STATE, READY);
          move_proc_fifo(state_info.running_0 /* {running_0} */,
                         &state_info.ready);
          current->need_resched = 1;
          return READY;
        }
        else {
          return READY;
        }
      }
    }
    default: {
      panic("Linux: unknown event %x\n",_event);
      return 0;
    }
  }
}

static int
Linux_compute_state(struct next_list_struct *tgt_next_list) {
  if (empty_proc(state_info.running_0)) {
    if ((empty_proc(state_info.yield) && empty_queue(&state_info.expired)) &&
        empty_queue(&state_info.ready)) {
      return BLOCKED;
    }
    else {
      return READY;
    }
  }
  else {
    return RUNNING;
  }
}

static void
Linux_preempt(void) {
  update_state(state_info.running_0, READY_STATE, READY);
  move_proc_fifo(state_info.running_0 /* {running_0} */, &state_info.ready);
  current->need_resched = 1;
  return;
}

inline static int
Linux_block(int _event,
            struct Linux_bossa_struct *tgt,
            struct next_list_struct *tgt_next_list) {
  prefetch(&state_info);
  {
    if (state_of(tgt) == RUNNING_0_STATE) {
      move_proc_queue(state_info.running_0 /* {running_0} */,
                      &state_info.blocked);
      current->need_resched = 1;
    }
    else {
      move_queue_queue(tgt /* {ready, expired} */, &state_info.blocked);
    }
    update_state(tgt, BLOCKED_STATE, BLOCKED);
    tgt->block_time = now();
    if (empty_queue(&state_info.expired) && empty_queue(&state_info.ready)) {
      running_active_mm = (struct mm_struct *)NULL;
      return BLOCKED;
    }
    else {
      return READY;
    }
  }
}

inline static int
Linux_block_bossa_schedule(void) {
  prefetch(&state_info);
  {
    if (empty_queue(&state_info.ready)) {
      {
        struct Linux_bossa_struct *p;
        struct list_head *_fresh_58;
        list_for_each(_fresh_58, &state_info.blocked) {
          p = list_entry(_fresh_58, struct Linux_bossa_struct, list_info);
          {
            p->ticks = (p->ticks / 2) + ((p->priority >> 2) + 1);
          }
        }
      }
      
      {
        struct Linux_bossa_struct *p;
        struct list_head *_fresh_59;
        struct list_head *_fresh_60;
        list_for_each_safe(_fresh_59, _fresh_60, &state_info.expired) {
          p = list_entry(_fresh_59, struct Linux_bossa_struct, list_info);
          {
            update_state(p, READY_STATE, READY);
            move_queue_fifo(p /* {expired} */, &state_info.ready);
          }
        }
      }
      
    }
    {
      struct Linux_bossa_struct * _fresh_20 = select_fifo_sort(&state_info.ready);
      
      update_state(_fresh_20, RUNNING_0_STATE, RUNNING);
      move_queue_proc(_fresh_20 /* {ready} */, state_info.running_0);
      running = (struct bossa_struct *)state_info.running_0;
    }
    running_active_mm = attr(state_info.running_0)->active_mm;
    return RUNNING;
  }
}

static int Linux_block_entry(int _event,
                             struct Linux_bossa_struct *tgt) {
  int res;
  res = Linux_block(_event,tgt,null);
  switch (res) {
    case BLOCKED: running = rts_idle_process;
    break;
    case READY:
    res = Linux_block_bossa_schedule();
  }
  return res;
}

inline static int
Linux_yield_system_immediate(int _event,
                             struct Linux_bossa_struct *tgt,
                             struct next_list_struct *tgt_next_list) {
  prefetch(&state_info);
  {
    if (state_of(tgt) == RUNNING_0_STATE) {
      update_state(tgt, READY_STATE, READY);
      move_proc_fifo(state_info.running_0 /* {running_0} */, &state_info.ready);
      current->need_resched = 1;
      return READY;
    }
    else {
      return READY;
    }
  }
}

inline static int
Linux_yield_system_immediate_bossa_schedule(void) {
  prefetch(&state_info);
  {
    if (empty_queue(&state_info.ready)) {
      {
        struct Linux_bossa_struct *p;
        struct list_head *_fresh_61;
        list_for_each(_fresh_61, &state_info.blocked) {
          p = list_entry(_fresh_61, struct Linux_bossa_struct, list_info);
          {
            p->ticks = (p->ticks / 2) + ((p->priority >> 2) + 1);
          }
        }
      }
      
      {
        struct Linux_bossa_struct *p;
        struct list_head *_fresh_62;
        struct list_head *_fresh_63;
        list_for_each_safe(_fresh_62, _fresh_63, &state_info.expired) {
          p = list_entry(_fresh_62, struct Linux_bossa_struct, list_info);
          {
            update_state(p, READY_STATE, READY);
            move_queue_fifo(p /* {expired} */, &state_info.ready);
          }
        }
      }
      
    }
    {
      struct Linux_bossa_struct * _fresh_21 = select_fifo_sort(&state_info.ready);
      
      update_state(_fresh_21, RUNNING_0_STATE, RUNNING);
      move_queue_proc(_fresh_21 /* {ready} */, state_info.running_0);
      running = (struct bossa_struct *)state_info.running_0;
    }
    running_active_mm = attr(state_info.running_0)->active_mm;
    return RUNNING;
  }
}

static int Linux_yield_system_immediate_entry(int _event,
                                              struct Linux_bossa_struct *tgt) {
  int res;
  res = Linux_yield_system_immediate(_event,tgt,null);
  switch (res) {
    case BLOCKED: running = rts_idle_process;
    break;
    case READY:
    res = Linux_yield_system_immediate_bossa_schedule();
  }
  return res;
}

inline static int
Linux_yield_system_pause(int _event,
                         struct Linux_bossa_struct *tgt,
                         struct next_list_struct *tgt_next_list) {
  prefetch(&state_info);
  {
    if (state_of(tgt) == RUNNING_0_STATE) {
      update_state(tgt, YIELD_STATE, READY);
      move_proc_proc(state_info.running_0 /* {running_0} */, state_info.yield);
      current->need_resched = 1;
      return READY;
    }
    else {
      return READY;
    }
  }
}

inline static int
Linux_yield_system_pause_bossa_schedule(void) {
  prefetch(&state_info);
  {
    if (empty_queue(&state_info.ready)) {
      {
        struct Linux_bossa_struct *p;
        struct list_head *_fresh_64;
        list_for_each(_fresh_64, &state_info.blocked) {
          p = list_entry(_fresh_64, struct Linux_bossa_struct, list_info);
          {
            p->ticks = (p->ticks / 2) + ((p->priority >> 2) + 1);
          }
        }
      }
      
      if (!empty_proc(state_info.yield)) {
        state_info.yield->ticks =
          (state_info.yield->ticks / 2) + ((state_info.yield->priority >> 2) + 1);
      }
      if (empty_queue(&state_info.expired)) {
        update_state(state_info.yield, READY_STATE, READY);
        move_proc_fifo(state_info.yield /* {yield} */, &state_info.ready);
      }
      else {
        {
          struct Linux_bossa_struct *p;
          struct list_head *_fresh_65;
          struct list_head *_fresh_66;
          list_for_each_safe(_fresh_65, _fresh_66, &state_info.expired) {
            p = list_entry(_fresh_65, struct Linux_bossa_struct, list_info);
            {
              update_state(p, READY_STATE, READY);
              move_queue_fifo(p /* {expired} */, &state_info.ready);
            }
          }
        }
        
      }
    }
    {
      struct Linux_bossa_struct * _fresh_19 = select_fifo_sort(&state_info.ready);
      
      update_state(_fresh_19, RUNNING_0_STATE, RUNNING);
      move_queue_proc(_fresh_19 /* {ready} */, state_info.running_0);
      running = (struct bossa_struct *)state_info.running_0;
    }
    running_active_mm = attr(state_info.running_0)->active_mm;
    if (empty_proc(state_info.yield)) {
      return RUNNING;
    }
    else {
      update_state(state_info.yield, READY_STATE, READY);
      move_proc_fifo(state_info.yield /* {yield} */, &state_info.ready);
      return RUNNING;
    }
  }
}

static int Linux_yield_system_pause_entry(int _event,
                                          struct Linux_bossa_struct *tgt) {
  int res;
  res = Linux_yield_system_pause(_event,tgt,null);
  switch (res) {
    case BLOCKED: running = rts_idle_process;
    break;
    case READY:
    res = Linux_yield_system_pause_bossa_schedule();
  }
  return res;
}

inline static int
Linux_unblock_preemptive(int _event,
                         struct Linux_bossa_struct *tgt,
                         struct next_list_struct *tgt_next_list) {
  int _fresh_67 = tgt->state;
  int _fresh_68 = (_fresh_67 == BLOCKED_STATE) << UNBLOCK_INFO_OFFSET;
  prefetch(&state_info);
  {
    if (state_of(tgt) == BLOCKED_STATE) {
      if (!(empty_proc(state_info.running_0) ||
            !greater(tgt, state_info.running_0))) {
        update_state(state_info.running_0, READY_STATE, READY);
        move_proc_fifo(state_info.running_0 /* {running_0} */,
                       &state_info.ready);
        current->need_resched = 1;
      }
      update_state(tgt, READY_STATE, READY);
      move_queue_fifo(tgt /* {blocked} */, &state_info.ready);
      if (empty_proc(state_info.running_0)) {
        return _fresh_68 | READY;
      }
      else {
        return _fresh_68 | RUNNING;
      }
    }
    else {
      if (empty_proc(state_info.running_0)) {
        return _fresh_68 | READY;
      }
      else {
        return _fresh_68 | RUNNING;
      }
    }
  }
}

static int Linux_unblock_preemptive_entry(int _event,
                                          struct Linux_bossa_struct *tgt) {
  int res;
  int unblock_res;
  res = Linux_unblock_preemptive(_event,tgt,null);
  unblock_res = get_unblock_res(res);
  res = drop_unblock_res(res);
  root_s_state = res;
  return unblock_res;
}

inline static int
Linux_bossa_schedule(void) {
  prefetch(&state_info);
  {
    if (empty_queue(&state_info.ready)) {
      {
        struct Linux_bossa_struct *p;
        struct list_head *_fresh_69;
        list_for_each(_fresh_69, &state_info.blocked) {
          p = list_entry(_fresh_69, struct Linux_bossa_struct, list_info);
          {
            p->ticks = (p->ticks / 2) + ((p->priority >> 2) + 1);
          }
        }
      }
      
      if (!empty_proc(state_info.yield)) {
        state_info.yield->ticks =
          (state_info.yield->ticks / 2) + ((state_info.yield->priority >> 2) + 1);
      }
      if (empty_queue(&state_info.expired)) {
        update_state(state_info.yield, READY_STATE, READY);
        move_proc_fifo(state_info.yield /* {yield} */, &state_info.ready);
      }
      else {
        {
          struct Linux_bossa_struct *p;
          struct list_head *_fresh_70;
          struct list_head *_fresh_71;
          list_for_each_safe(_fresh_70, _fresh_71, &state_info.expired) {
            p = list_entry(_fresh_70, struct Linux_bossa_struct, list_info);
            {
              update_state(p, READY_STATE, READY);
              move_queue_fifo(p /* {expired} */, &state_info.ready);
            }
          }
        }
        
      }
    }
    {
      struct Linux_bossa_struct * _fresh_18 = select_fifo_sort(&state_info.ready);
      
      update_state(_fresh_18, RUNNING_0_STATE, RUNNING);
      move_queue_proc(_fresh_18 /* {ready} */, state_info.running_0);
      running = (struct bossa_struct *)state_info.running_0;
    }
    running_active_mm = attr(state_info.running_0)->active_mm;
    if (empty_proc(state_info.yield)) {
      return RUNNING;
    }
    else {
      update_state(state_info.yield, READY_STATE, READY);
      move_proc_fifo(state_info.yield /* {yield} */, &state_info.ready);
      return RUNNING;
    }
  }
}

static int Linux_bossa_schedule_entry(void) {
  int res;
  res = Linux_bossa_schedule();
  return res;
}

inline static int
Linux_unblock_timer_target(int _event,
                           struct Linux_bossa_struct *tgt,
                           struct next_list_struct *tgt_next_list) {
  prefetch(&state_info);
  {
    panic("Linux: unknown event %x\n",_event);
    return 0;
  }
}

static int Linux_unblock_timer_target_entry(int _event,
                                            struct Linux_bossa_struct *tgt,
                                            struct next_list_struct *next_list) {
  int res;
  res = Linux_unblock_timer_target(_event,tgt,next_list);
  return res;
}

inline static int
Linux_unblock_timer_notarget(int _event,
                             struct Linux_bossa_struct *tgt,
                             struct next_list_struct *tgt_next_list) {
  prefetch(&state_info);
  {
    panic("Linux: unknown event %x\n",_event);
    return 0;
  }
}

static int Linux_unblock_timer_notarget_entry(int _event,
                                              struct Linux_bossa_struct *tgt,
                                              struct next_list_struct *next_list) {
  int res;
  res = Linux_unblock_timer_notarget(_event,tgt,next_list);
  return res;
}

inline static int
Linux_unblock_timer_persistent(int _event,
                               struct timer_list *self,
                               void *local_data,
                               int target_alive,
                               struct Linux_bossa_struct *tgt,
                               struct next_list_struct *tgt_next_list) {
  prefetch(&state_info);
  {
    panic("Linux: unknown event %x\n",_event);
    return 0;
  }
}

static int Linux_unblock_timer_persistent_entry(int _event,
                                                struct timer_list *self,
                                                void *local_data,
                                                int target_alive,
                                                struct Linux_bossa_struct *tgt,
                                                struct next_list_struct *next_list) {
  int res;
  res = Linux_unblock_timer_persistent(_event,self,local_data,target_alive,tgt,next_list);
  return res;
}

static int xcount = 0;
static int total_size = 0;

#define buffer_extend(tmp,size,buffer,ret) \
  do { \
    if (!xcount || size + total_size < xcount) { \
      total_size += size; \
      buffer = size + strcpy(buffer,tmp); \
    } \
    else { \
      return ret; \
    } \
  } while(0)

static int Linux_do_schedprocinfo(char *buffer, bool long_format) {
  char *orig_buffer = buffer;
  char tmp[500];
  int size;
  
  size = sprintf(tmp,"\t\t\tLinux\n\t\t\t%s\n\n",sched_type[EXPORTS.type]);
  buffer_extend(tmp,size,buffer,total_size);
  size = sprintf(tmp,"Child processes:\n");
  buffer_extend(tmp,size,buffer,total_size);
  size = sprintf(tmp, "\t\t%-3s%-5s%-9.8s%-6s", "", "Pid", "Command", "State");
  buffer_extend(tmp,size,buffer,total_size);
  size = sprintf(tmp, " %-5.4s %-5.4s %-5.4s %-5.4s %-5.4s %-5.4s %-8.7s\n",
  "policy",
  "rt_priority",
  "priority",
  "ticks",
  "block_time",
  "block_event",
  "active_mm");
  buffer_extend(tmp,size,buffer,total_size);
  size = sprintf(tmp, "%-19s","running_0 process: ");
  buffer_extend(tmp,size,buffer,total_size);
  if (!state_info.running_0) {
    size = sprintf(tmp, "null\n");
    buffer_extend(tmp,size,buffer,total_size);
  }
  else {
    buffer += Linux_do_taskprocinfo(NULL,(struct bossa_struct *)state_info.running_0,buffer,false,long_format,true);
    if (!long_format) {
      size = sprintf(tmp, "\n");
      buffer_extend(tmp,size,buffer,total_size);
    }
  }
  size = sprintf(tmp, "%-19s","ready queue: ");
  buffer_extend(tmp,size,buffer,total_size);
  buffer = queueToString(&state_info.ready,buffer,long_format);
  
  size = sprintf(tmp, "%-19s","expired queue: ");
  buffer_extend(tmp,size,buffer,total_size);
  buffer = queueToString(&state_info.expired,buffer,long_format);
  
  size = sprintf(tmp, "%-19s","yield process: ");
  buffer_extend(tmp,size,buffer,total_size);
  if (!state_info.yield) {
    size = sprintf(tmp, "null\n");
    buffer_extend(tmp,size,buffer,total_size);
  }
  else {
    buffer += Linux_do_taskprocinfo(NULL,(struct bossa_struct *)state_info.yield,buffer,false,long_format,true);
    if (!long_format) {
      size = sprintf(tmp, "\n");
      buffer_extend(tmp,size,buffer,total_size);
    }
  }
  size = sprintf(tmp, "%-19s","blocked queue: ");
  buffer_extend(tmp,size,buffer,total_size);
  buffer = queueToString(&state_info.blocked,buffer,long_format);
  
  
  return strlen(orig_buffer); // Should use strnlen ...
}

static char *
queueToString(struct list_head *start, char *buffer, bool long_format) {
  struct Linux_bossa_struct *p;
  struct list_head *elem;
  char tmp[500];
  int size;
  
  if (list_empty(start)) {
    size = sprintf(tmp,"null\n");
    buffer_extend(tmp,size,buffer,buffer);
  }
  else {
    bool first = true;
    list_for_each(elem, start) {
      p = list_entry(elem, struct Linux_bossa_struct, list_info);
      buffer += Linux_do_taskprocinfo(NULL,
                                      (struct bossa_struct *)p,
                                      buffer,
                                      elem==start,
                                      long_format,
                                      first);
      first = false;
    }
    if (!long_format) {
      size = sprintf(tmp, "\n");
      buffer_extend(tmp,size,buffer,buffer);
    }
  }
  return buffer;
}

static int Linux_do_taskprocinfo(struct next_list_struct *next_list,
                                 struct bossa_struct *bossa,
                                 char *buffer,
                                 bool w_header,
                                 bool long_format,
                                 bool first) {
  struct Linux_bossa_struct * p = (struct Linux_bossa_struct *) bossa;
  char * b = buffer;
  char tmp[500];
  int size;
  
  if (bossa == null) {
    printk("Linux: Ups! Null process.\n");
    return 0;
  }
  if (attr(p) == null) return 0;
  
  if (long_format) {
    if (w_header) {
      size = sprintf(tmp,"Linux\n");
      buffer_extend(tmp,size,buffer,total_size);
      size = sprintf(tmp, "%-5s%-9.8s%-6s", "Pid", "Command", "State");
      buffer_extend(tmp,size,buffer,total_size);
      size = sprintf(tmp, " %-5.4s %-5.4s %-5.4s %-5.4s %-5.4s %-5.4s %-8.7s\n",
      "policy",
      "rt_priority",
      "priority",
      "ticks",
      "block_time",
      "block_event",
      "active_mm");
      buffer_extend(tmp,size,buffer,total_size);
    }
    if (first) {
      size = sprintf(tmp, "%-5d%-9.8s%-6d",attr(p)->pid,attr(p)->comm,p->state);
      buffer_extend(tmp,size,buffer,total_size);
    }
    else {
      size = sprintf(tmp, "\t\t%-3s%-5d%-9.8s%-6d", "",attr(p)->pid,attr(p)->comm,p->state);
      buffer_extend(tmp,size,buffer,total_size);
    }
    first = false;
    size = sprintf(tmp, " %-5d %-5d %-5d %-5d %-5ld %-5d %-8x\n",
    p->policy,
    p->rt_priority,
    p->priority,
    p->ticks,
    p->block_time,
    p->block_event,
    (attr(p))->active_mm);
    buffer_extend(tmp,size,buffer,total_size);
  }
  else {
    size = sprintf(tmp,"%d ",(attr(p))->pid);
    buffer_extend(tmp,size,buffer,total_size);
  }
  return strlen(b); // Should use strnlen ...
}

static int Linux_list_sched_info(char * page,
                                 char ** start,
                                 off_t off,
                                 int count,
                                 int * eof,
                                 void * data) {
  int res;
  ulong flags=0;
  
  spin_lock_irqsave(&bossa_scheduler_lock,flags);
  xcount = count;
  total_size = 0;
  res = Linux_do_schedprocinfo(page, true);
  xcount = 0;
  total_size = 0;
  spin_unlock_irqrestore(&bossa_scheduler_lock,flags);
  return res;
}

static void Linux_print_processes(void) {
  print_var("running_0", state_info.running_0);
  print_queue("ready", &state_info.ready);
  print_queue("expired", &state_info.expired);
  print_var("yield", state_info.yield);
  print_queue("blocked", &state_info.blocked);
  
}

static int Linux_count_processes(void) {
  int total_75 = 0;
  total_75 += count_var(state_info.running_0);
  total_75 += count_queue(&state_info.ready);
  total_75 += count_queue(&state_info.expired);
  total_75 += count_var(state_info.yield);
  total_75 += count_queue(&state_info.blocked);
  return total_75;
}

/* executed when the scheduler is added to the hierarchy */
static void Linux_attach_self(void) {
  /* initialization of timer variables */
  
}

static PROTOCOL_SCHEDULER_STRUCT *Linux_detach_self(bool is_root) {
  if (!is_root && Linux_count_processes() == 0
#ifdef MODULE
   && !MOD_IN_USE
#endif
  ){
    if (EXPORTS.next_list.prev->prev != &(EXPORTS.next_list))
      EXPORTS.next_list.prev->prev->sched->ops->detach(EXPORTS.next_list.prev->sched,true);
    return null;
  }
  else {
    printk("cannot detach Linux\n");
    errno = -EINVAL;
    return (PROTOCOL_SCHEDULER_STRUCT *)FAILURE;
  }
  return null;
}

static void Linux_set_priority(struct Linux_bossa_struct *p,
                               struct next_list_struct *nl, int niceval) {
  p->priority = 20-niceval;
}

// --------------------- interface functions ---------------------
// checksum = 21541


static int major;
static devfs_handle_t devfs_handle;
static devfs_handle_t devfs_handle2;
extern spinlock_t bossa_scheduler_lock;


#define BOSSA_ID_NUM 0xCE
#define IOCTL_SET_PRIORITY           _IOW(BOSSA_ID_NUM, 0, int)
#define IOCTL_ATTACH                 _IOW(BOSSA_ID_NUM, 255, int)
#define IOCTL_SCHED_SETSCHEDULER     _IOW(BOSSA_ID_NUM, 1, int)
#define BOSSA_DEVICE_NAME "bossa_Linux"


static inline struct Linux_bossa_struct *find_process_by_pid(pid_t pid) {
  struct task_struct *tsk;
  
  if (pid) {
    //read_lock_irq(&tasklist_lock);
    tsk = find_task_by_pid(pid);
    //read_unlock_irq(&tasklist_lock);
  }
  else tsk = current;
  return (struct Linux_bossa_struct *)(&tsk->bossa);
}

struct dev_Linux_set_priority_struct {
  int p;
  int niceval;
};

struct dev_Linux_attach_struct {
  int _checksum;
  int p_11;
  enum policy_t policy_12;
  int rt_priority_13;
  int niceval_14;
};

struct dev_Linux_sched_setscheduler_struct {
  int p;
  enum policy_t policy;
  int prio;
};

static struct Linux_bossa_struct * p_11;
static enum policy_t policy_12;
static int rt_priority_13;
static int niceval_14;

static inline int _dev_Linux_ioctl(uint ioctl_num,
                                   ulong param) {
  errno = 0;
  if (EXPORTS.next_list.next == &(EXPORTS.next_list)) {
    printk("Linux not loaded\n");
    errno = -EINVAL;
    return FAILURE;
  }
  switch (ioctl_num) {
    case IOCTL_SET_PRIORITY: {
      struct dev_Linux_set_priority_struct data;
      struct Linux_bossa_struct * p;
      int niceval;
      copy_from_user(&data,
                     (struct dev_Linux_set_priority_struct *)param,
                     sizeof(struct dev_Linux_set_priority_struct));
      p = find_process_by_pid(data.p);
      niceval = data.niceval;
      if (p==null) {
        printk("unknown process\n");
        errno = -EINVAL;
        return FAILURE;
      }
      if (p->next_list != &(EXPORTS.next_list)) {
        printk("process argument p must be managed by the current scheduler\n");
        errno = -EINVAL;
        return FAILURE;
      }
      {
        if ((niceval < (0 - 20)) || (niceval > 20)) {
          printk("invalid niceval\n");
          errno = -EINVAL;
          return FAILURE;
        }
        p->priority = 20 - niceval;
        return SUCCESS;
      }
    }
    case IOCTL_ATTACH: {
      struct dev_Linux_attach_struct data;
      copy_from_user(&data,
                     (struct dev_Linux_attach_struct *)param,
                     sizeof(struct dev_Linux_attach_struct));
      p_11 = find_process_by_pid(data.p_11);
      policy_12 = data.policy_12;
      rt_priority_13 = data.rt_priority_13;
      niceval_14 = data.niceval_14;
      if (p_11==null) {
        printk("unknown process\n");
        errno = -EINVAL;
        return FAILURE;
      }
      {
        struct Linux_bossa_struct before_attach;
        struct Linux_bossa_struct after_attach;
        
        error_string = "";
        if (errno != 0) {
          printk("some error has previously occurred\n");
          errno = -EINVAL;
          return FAILURE;
        }
        // 0 checksum allowed for eg hourglass, that doesn't use attach
        if (data._checksum && data._checksum != 21541) {
          printk("stub functions are out of date, attach to Linux refused\n");
          errno = -EINVAL;
          return FAILURE;
        }
        if (p_11->next_list == &(EXPORTS.next_list)) {
          printk("can't move from a scheduler (Linux) to itself\n");
          errno = -EINVAL;
          return FAILURE;
        }
        set_current_need_resched(1);
        memcpy(&before_attach,p_11,sizeof(struct Linux_bossa_struct));
        EXPORTS.next_list.next->sched->ops->ps_attach(EXPORTS.next_list.next->next);
        memcpy(&after_attach,p_11,sizeof(struct Linux_bossa_struct));
        memcpy(p_11,&before_attach,sizeof(struct Linux_bossa_struct));
        if (errno == 0) {
          root_s_state =
            p_11->next_list->next->sched->ops->ps_detach(p_11->next_list->next->next,
                                                         (struct bossa_struct *)p_11);
          memcpy(p_11,&after_attach,sizeof(struct Linux_bossa_struct));
          p_11->next_list = &(EXPORTS.next_list);
          if (errno != 0) {
            printk("Some error has occurred in detach\nThe original scheduler may now be in an inconsistent state\n");
            errno = -EINVAL;
            return FAILURE;
          }
        }
        else {
          printk("%s",error_string);
          printk("Some error has occurred in attach to Linux\n");
          errno = -EINVAL;
          return FAILURE;
        }
      }
      return SUCCESS;
    }
    case IOCTL_SCHED_SETSCHEDULER: {
      struct dev_Linux_sched_setscheduler_struct data;
      struct Linux_bossa_struct * p;
      enum policy_t policy;
      int prio;
      copy_from_user(&data,
                     (struct dev_Linux_sched_setscheduler_struct *)param,
                     sizeof(struct dev_Linux_sched_setscheduler_struct));
      p = find_process_by_pid(data.p);
      policy = data.policy;
      prio = data.prio;
      if (p==null) {
        printk("unknown process\n");
        errno = -EINVAL;
        return FAILURE;
      }
      if (p->next_list != &(EXPORTS.next_list)) {
        printk("process argument p must be managed by the current scheduler\n");
        errno = -EINVAL;
        return FAILURE;
      }
      {
        p->policy = policy;
        if ((policy == BOSSA_SCHED_OTHER) && (prio != 0)) {
          printk("invalid priority for non-RT process\n");
          errno = -EINVAL;
          return FAILURE;
        }
        else {
          if ((prio < 0) || (prio > 99)) {
            printk("invalid priority for RT process\n");
            errno = -EINVAL;
            return FAILURE;
          }
        }
        if ((policy != BOSSA_SCHED_OTHER) && (state_of(p) == EXPIRED_STATE)) {
          update_state(p, READY_STATE, READY);
          move_queue_fifo(p /* {expired} */, &state_info.ready);
        }
        p->rt_priority = prio;
        goto out_sched_setscheduler;
      }
      out_sched_setscheduler:
      root_s_state =
        EXPORTS.next_list.next->sched->ops->compute_state(EXPORTS.next_list.next->next);
      return SUCCESS;
    }
  }
  printk("error occurred in Linux\n");
  errno = -EINVAL;
  return FAILURE;
}

static int dev_Linux_ioctl(struct inode *inode,
                           struct file *fd,
                           uint ioctl_num,
                           ulong param) {
  int res;
  ulong flags=0;
  
  spin_lock_irqsave(&bossa_scheduler_lock,flags);
  res = _dev_Linux_ioctl(ioctl_num,param);
  spin_unlock_irqrestore(&bossa_scheduler_lock,flags);
  return res;
}

static struct file_operations procfops = {
  ioctl: dev_Linux_ioctl
};


static int __init Linux_ioctl_init(void) {
  devfs_handle = devfs_mk_dir (null, "bossa", null);
  major = devfs_register_chrdev(0, BOSSA_DEVICE_NAME, &procfops);
  if (major < 0) {
    printk("devfs_register_chrdev failed\n");
    return -ENODEV;
  }
  devfs_handle2 = devfs_register(devfs_handle, BOSSA_DEVICE_NAME, DEVFS_FL_DEFAULT,
                                  major, 0,
                                  S_IFCHR | S_IRUGO | S_IWUGO,
                                  &procfops, NULL);
  return 0;
}

static int Linux_ps_attach(struct next_list_struct *next) {
  if ((policy_12 == BOSSA_SCHED_OTHER) && (rt_priority_13 != 0)) {
    error_string = "invalid priority for non-RT process\n";
    errno = -EINVAL;
    return FAILURE;
  }
  else {
    if ((rt_priority_13 < 0) || (rt_priority_13 > 99)) {
      error_string = "invalid priority for RT process\n";
      errno = -EINVAL;
      return FAILURE;
    }
  }
  if ((policy_12 != BOSSA_SCHED_FIFO) &&
      ((niceval_14 < (0 - 20)) || (niceval_14 > 20))) {
    error_string = "invalid niceval\n";
    errno = -EINVAL;
    return FAILURE;
  }
  p_11->block_time = ticks_to_time(0);
  p_11->block_event = 0;
  p_11->policy = policy_12;
  p_11->rt_priority = rt_priority_13;
  p_11->priority = 20 - niceval_14;
  p_11->ticks = (p_11->priority >> 2) + 1;
  update_state(p_11, READY_STATE, READY);
  move_nowhere_fifo(p_11 /* {} */, &state_info.ready);
  increment_ref_count();
  if (empty_proc(state_info.running_0)) {
    return READY;
  }
  else {
    return RUNNING;
  }
}

static int Linux_ps_detach(struct next_list_struct *next,
                           struct bossa_struct *_p) {
  struct Linux_bossa_struct *p = (struct Linux_bossa_struct *)_p;
  {
    decrement_ref_count();
    if (running_active_mm == attr(p)->active_mm) {
      running_active_mm = (struct mm_struct *)NULL;
      if (state_of(p) == RUNNING_0_STATE) {
        update_state(p, TERMINATED_STATE, TERMINATED);
        move_proc_nowhere(state_info.running_0 /* {running_0} */,
                          &state_info.terminated);
        current->need_resched = 1;
      }
      else {
        update_state(p, TERMINATED_STATE, TERMINATED);
        move_queue_nowhere(p /* {ready, expired, blocked} */,
                           &state_info.terminated);
      }
      if (empty_proc(state_info.running_0)) {
        if (empty_queue(&state_info.expired) && empty_queue(&state_info.ready)) {
          return BLOCKED;
        }
        else {
          return READY;
        }
      }
      else {
        return RUNNING;
      }
    }
    else {
      if (state_of(p) == RUNNING_0_STATE) {
        update_state(p, TERMINATED_STATE, TERMINATED);
        move_proc_nowhere(state_info.running_0 /* {running_0} */,
                          &state_info.terminated);
        current->need_resched = 1;
      }
      else {
        update_state(p, TERMINATED_STATE, TERMINATED);
        move_queue_nowhere(p /* {ready, expired, blocked} */,
                           &state_info.terminated);
      }
      if (empty_proc(state_info.running_0)) {
        if (empty_queue(&state_info.expired) && empty_queue(&state_info.ready)) {
          return BLOCKED;
        }
        else {
          return READY;
        }
      }
      else {
        return RUNNING;
      }
    }
  }
}

#ifdef MODULE
static void unregister(void) {
  devfs_unregister_chrdev(major, BOSSA_DEVICE_NAME);
  devfs_unregister(devfs_handle2);
}
#endif
