// to be included in kernel/fork.c

static void inline bossa_new_process(int caller, struct task_struct *p) {
  // replaces wake_up code, switch state before root
  p->state = TASK_RUNNING;
  bossa_create_process(p, &(current->bossa));
  if (p->pid == 1) {
    /* first process to run, attach it */
    BOSSA_NOTIFY_EVENT(EVENT_PROCESS_NEW, &(p->bossa), NULL);
    if (root_s_state == READY) current->need_resched = 1;
  }
  else {
    BOSSA_NOTIFY_EVENT(EVENT_PROCESS_NEW, &(p->bossa), &(current->bossa));
  }
}
